﻿
using AutoClick;
using System;
using System.Collections.Generic;

using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Automation;
using System.Windows.Forms;
using System.Windows;
using System.Threading;
namespace Send2OpenLabCDS.LibOpenLabCDS
{
    class TEST_CDS
    {
        AutomationElement desktop = AutomationElement.RootElement;
        AutomationElement Wnd = null;
        int ScreenWidth = 0;
        int ScreenHeight = 0;

        public TEST_CDS(string wndName)
        {
            Wnd = desktop.FindFirst(TreeScope.Children, new PropertyCondition(AutomationElement.NameProperty,wndName));
            if(Wnd==null)
            {
                MessageBox.Show("No such wnd");
            }else
            {
                //MessageBox.Show("Find the window " + Wnd.Current.Name+"with rect "+Wnd.Current.BoundingRectangle.ToString());
                
                ScreenWidth = Screen.PrimaryScreen.WorkingArea.Width;
                ScreenHeight = Screen.PrimaryScreen.WorkingArea.Height;
                
            }
        }
        public void TestButton()
        {


            var box = Wnd.FindFirst(TreeScope.Descendants, new PropertyCondition(AutomationElement.AutomationIdProperty, "button4"));
            if(box==null)
            {
                MessageBox.Show("no such button");
            }
            WindowsApi.SetForegroundWindow((IntPtr)Wnd.Current.NativeWindowHandle);
            //box.SetFocus();
            WindowsApi.PostMessage((IntPtr)box.Current.NativeWindowHandle, 0x0101, 0x01, 0);



        }
        public void TestListItem()
        {
            string ControlName = "开始";

            var lbStart = Wnd.FindFirst(TreeScope.Descendants, new AndCondition(new PropertyCondition(AutomationElement.ControlTypeProperty, ControlType.Text), new PropertyCondition(AutomationElement.NameProperty, "开始")));


            string ListItemName = "序列";
            var c1=new PropertyCondition(AutomationElement.ControlTypeProperty,ControlType.ListItem);
            var c2=new PropertyCondition(AutomationElement.NameProperty,ListItemName);
            var itemSeq = Wnd.FindFirst(TreeScope.Descendants, new AndCondition(c1, c2));
            if (itemSeq == null)
            {
                MessageBox.Show("No ListItem序列found");
            }else
            {
                System.Windows.Point p=new Point();
                WindowsApi.SetForegroundWindow((IntPtr)Wnd.Current.NativeWindowHandle);
                WindowsApi.ShowWindow((IntPtr)Wnd.Current.NativeWindowHandle, 3);
                if (itemSeq.TryGetClickablePoint(out p))
                {
                    WindowsApi.SetCursorPos((int)p.X, (int)p.Y);
                    WindowsApi.mouse_event(WindowsApi.MOUSEEVENTF_LEFTDOWN | WindowsApi.MOUSEEVENTF_LEFTUP, 0, 0, 0, (UIntPtr)0);

                }

            }
            
            
        }

        public void TestImport()
        {
            string helpText = "从 CSV/TSV 或结果集导入序列";
            var c1 = new PropertyCondition(AutomationElement.ControlTypeProperty, ControlType.Button);
            var c2 = new PropertyCondition(AutomationElement.HelpTextProperty, helpText);
            var importBtn = Wnd.FindFirst(TreeScope.Descendants, new AndCondition(c1, c2));
            if(importBtn==null)
            {
                MessageBox.Show("No button import found");
            }else
            {
                Object p = null;
                if(importBtn.TryGetCurrentPattern(InvokePattern.Pattern, out p))
                {
                    InvokePattern p1 = p as InvokePattern;
                    p1.Invoke();
                }

            }
        }

        public void TestImport2()
        {
            string name = "从 CSV 或 TSV 导入序列";
            var c1 = new PropertyCondition(AutomationElement.ControlTypeProperty, ControlType.Text);
            var c2 = new PropertyCondition(AutomationElement.NameProperty, name);

            var text=Wnd.FindFirst(TreeScope.Descendants,new AndCondition(c1,c2));
            if(text==null)
            {
                MessageBox.Show("No text import found");
            }else
            {
                System.Windows.Point p = new Point();
                WindowsApi.SetForegroundWindow((IntPtr)Wnd.Current.NativeWindowHandle);
                WindowsApi.ShowWindow((IntPtr)Wnd.Current.NativeWindowHandle, 1);
                if (text.TryGetClickablePoint(out p))
                {
                    WindowsApi.SetCursorPos((int)p.X, (int)p.Y);
                    WindowsApi.mouse_event(WindowsApi.MOUSEEVENTF_LEFTDOWN | WindowsApi.MOUSEEVENTF_LEFTUP, 0, 0, 0, (UIntPtr)0);

                }

            }
        }

        internal void TestBrowserWindow()
        {
            TestImport();
            TestImport2();
            Thread.Sleep(500);
            var c1 = new PropertyCondition(AutomationElement.ControlTypeProperty, ControlType.Window);
            var c2 = new PropertyCondition(AutomationElement.NameProperty, "打开");
            var broWnd = desktop.FindFirst(TreeScope.Descendants, new AndCondition(c1, c2));
            if(broWnd!=null)
            {
                //MessageBox.Show(broWnd.Current.ProcessId.ToString());
            }

            var EditC1 = new PropertyCondition(AutomationElement.ControlTypeProperty, ControlType.Edit);
            var EditC2 = new PropertyCondition(AutomationElement.AutomationIdProperty, "1148");

            var edit = broWnd.FindFirst(TreeScope.Descendants, new AndCondition(EditC1, EditC2));
            {
                //MessageBox.Show("Edit name" + edit.Current.Name);
            }
            Object e = null;
            if(edit.TryGetCurrentPattern(ValuePattern.Pattern,out e))
            {
                ValuePattern e1 = e as ValuePattern;
                e1.SetValue("%temp%\\store4seq");
            }

            WindowsApi.SetForegroundWindow((IntPtr)broWnd.Current.NativeWindowHandle);
            edit.SetFocus();
            SendKeys.SendWait("{ENTER}");

            var filec1 = new PropertyCondition(AutomationElement.ControlTypeProperty, ControlType.ListItem);
            var filec2 = new PropertyCondition(AutomationElement.NameProperty, "SeqFileMeth.csv");

            var file = broWnd.FindFirst(TreeScope.Descendants, new AndCondition(filec1, filec2));
            if(file!=null)
            {
                //MessageBox.Show("file name" + file.Current.Name);
            }
            System.Windows.Point p = new Point();
            WindowsApi.SetForegroundWindow((IntPtr)broWnd.Current.NativeWindowHandle);
            WindowsApi.ShowWindow((IntPtr)broWnd.Current.NativeWindowHandle, 1);
            if (file.TryGetClickablePoint(out p))
            {
                WindowsApi.SetCursorPos((int)p.X, (int)p.Y);
                WindowsApi.mouse_event(WindowsApi.MOUSEEVENTF_LEFTDOWN | WindowsApi.MOUSEEVENTF_LEFTUP, 0, 0, 0, (UIntPtr)0);

            }

            
                var b1 = new PropertyCondition(AutomationElement.ControlTypeProperty, ControlType.Button);
                var b2 = new PropertyCondition(AutomationElement.NameProperty, "打开(O)");
                var btnOpen = broWnd.FindFirst(TreeScope.Descendants, new AndCondition(b1, b2));
                if (btnOpen == null)
                {
                    MessageBox.Show("No button import found");
                }
                else
                {
                    Object open = null;
                    if (btnOpen.TryGetCurrentPattern(InvokePattern.Pattern, out open))
                    {
                        InvokePattern p2 = open as InvokePattern;
                        p2.Invoke();
                    }

                }
            

        }
    }
}
